#include <stdio.h>
#include <string.h>

#include <xcipher.h>

/*
  ͸ AES256/CBC/PKCS5 ȣȭ  ȣȭ , BASE64 encodingѴ.
  ĸ
    - plaintext : ȣȭ 
    - plaintext_size : ȣȭ  
    - ciphertext : ȣȭ  Ͱ  buffer
    - ciphertext_size : ȣȭ  Ͱ  buffer ũ
    - result_size : ȣȭ Ϸ   
  return
    -1: ȣȭ 
    0: 
*/
static long encrypt_aes256_cbc_pkcs5_base64(
            const char *plaintext, long plaintext_size,
            char *ciphertext, long ciphertext_size,
            const char *key, const char *iv, long *result_size)
{
    XCIPHER_io_t aes256;
    XCIPHER_io_t base64;
    char aes_out_buf[ciphertext_size];
   
    /* aes256/CBC/PKCS5 padding  ȣȭ ϱ */
    memset(&aes256, 0x00, sizeof(XCIPHER_io_t));
    memset(aes_out_buf, 0x00, sizeof(aes_out_buf));
    XCIPHER_init_aes256_cbc(&aes256, key, 32, iv, 16);
    XCIPHER_set_io(&aes256, plaintext, plaintext_size, aes_out_buf, sizeof(aes_out_buf));

    if(XCIPHER_encrypt(&aes256) != 0) {
        fprintf(stderr, "%s", aes256.out.err_msg);
        return -1;
    }
   
    ///////////////////////////////////////////////////
    memset(&base64, 0x00, sizeof(XCIPHER_io_t));
    XCIPHER_init_base64(&base64);
    // aes256 output base64 input...
    XCIPHER_set_io(&base64, aes_out_buf, aes256.out.size, ciphertext, ciphertext_size);

    if(XCIPHER_encrypt(&base64) != 0) {
        fprintf(stderr, "%s", base64.out.err_msg);
        return -1;
    }

    *result_size = base64.out.size;
   
    return 0;
}

/*
  AES256/CBC/PKCS5  ȣȣ  BASE64 encoding ͸ ȣȭѴ.
  Ķ:
    - ciphertext : ȣȭ Ϸ base64 encoding 
    - ciphertext_size : ciphertext  
    - plaintext : ȣȭ Ŀ  buffer
    - plaintext_size : plaintext buffer ũ
    - result_size : ȣȭ Ϸ  
  return:
    -1 : ȣȭ 
    0: ȣȭ 
*/
static long decrypt_base64_aes256_cbc_pkcs5(
            const char *ciphertext, long ciphertext_size,
            char *plaintext, long plaintext_size,
            const char *key, const char *iv, long *result_size)
{
    XCIPHER_io_t aes256;
    XCIPHER_io_t base64;
    char base64_out_buf[plaintext_size];

    /* BASE64 encoding  decodingϱ */
    memset(&base64, 0x00, sizeof(XCIPHER_io_t));
    memset(base64_out_buf, 0x00, sizeof(base64_out_buf));
    XCIPHER_init_base64(&base64);
    XCIPHER_set_io(&base64, ciphertext, ciphertext_size, base64_out_buf, sizeof(base64_out_buf));

    if(XCIPHER_decrypt(&base64) != 0) {
        fprintf(stderr, "[%s]", base64.out.err_msg);
        return -1;
    }

    /* aes256/CBC/PKCS5 padding  ȣȭ  ȣȭ ϱ */
    memset(&aes256, 0x00, sizeof(XCIPHER_io_t));
    XCIPHER_init_aes256_cbc(&aes256, key, 32, iv, 16);
    /* base64 decoding ͸ ȣȭ ϱ Ͽ base64 output Ϳ ũ⸦ input */
    XCIPHER_set_io(&aes256, base64.out.data, base64.out.size, plaintext, plaintext_size);

    if(XCIPHER_decrypt(&aes256) != 0) {
        fprintf(stderr, "[%s]", aes256.out.err_msg);
        return -1;
    }
    *result_size = aes256.out.size;
    return 0;
}

int main(int argc, char **argv)
{
    const unsigned char key[] = "12345678901234561234567890123456";
    const unsigned char iv[] = "1234567890123456";
    char buf[] = "1234567890ABCDEFGHIJKLMNOPQRSTUVWXYZٶ";
    char out_buf[1024];
    long out_buf_size = 1024;
    char base64_out_buf[1024];
    long base64_out_buf_size = 1024;
    long buf_size = strlen(buf);
    long idx;
    long ret;
    long result_size;

    /*
      buf -> ȣȭ base64 ȯ -> base64_out_buf 
    */
    memset(base64_out_buf, 0x00, sizeof(base64_out_buf));
    if((encrypt_aes256_cbc_pkcs5_base64(buf, strlen(buf), base64_out_buf, base64_out_buf_size, key, iv, &result_size)) != 0) {
        return -1;
    }
    base64_out_buf_size = result_size;
    printf("\nAES256 encoding....\n");
    printf("[%s] -> [%s]\n", buf, base64_out_buf);

    /*
      base64_out_buf -> base64 decode ȣȭ   ȣȭ -> out_buf 
    */
    memset(out_buf, 0x00, sizeof(out_buf));

    if((decrypt_base64_aes256_cbc_pkcs5(base64_out_buf, base64_out_buf_size, out_buf, out_buf_size, key, iv, &result_size))!= 0) {
        return -1;
    }
    out_buf_size = result_size;
    printf("\nAES256 decoding....\n");
    printf("[%s] -> [%s]\n\n", base64_out_buf, out_buf);


    printf("==========================================================\n");
    printf("\nDATA -> HEX\n");
    
    char tmp_hex[1024];
    char tmp_txt[1024];
    XCIPHER_io_t hex;
    memset(&hex, 0x00, sizeof(XCIPHER_io_t));
   
    memset(tmp_hex, 0x00, sizeof(tmp_hex));
    memset(tmp_txt, 0x00, sizeof(tmp_txt));
    XCIPHER_init_HEX(&hex);
    XCIPHER_set_io(&hex, buf, strlen(buf), tmp_hex, sizeof(tmp_hex));
    if(XCIPHER_encrypt(&hex) == -1) {
        fprintf(stderr, "%s\n", hex.out.err_msg);
        return 0;
    }
   
    printf("[%s] -> [%s]\n", buf, tmp_hex);
    XCIPHER_init_HEX(&hex);
    XCIPHER_set_io(&hex, tmp_hex, strlen(tmp_hex), tmp_txt, sizeof(tmp_txt));
    if(XCIPHER_decrypt(&hex) == -1) {
        fprintf(stderr, "%s\n", hex.out.err_msg);
        return 0;
    }
    printf("[%s] -> [%s]\n", tmp_hex, tmp_txt);

    return 0;
}

/*
))
gcc -o xcipher_sample *.c -I. -lcrypto
AES256 encoding....
[1234567890ABCDEFGHIJKLMNOPQRSTUVWXYZٶ] -> [lTFrs9iYNhrp0+i0le6dXTGtaS3jehtzwxmJyjDVsp7PwfV5qKZP3fu07UZ/43p8G4qk/vM+NYOLkDKfuPN80w==]

AES256 decoding....
[lTFrs9iYNhrp0+i0le6dXTGtaS3jehtzwxmJyjDVsp7PwfV5qKZP3fu07UZ/43p8G4qk/vM+NYOLkDKfuPN80w==] -> [1234567890ABCDEFGHIJKLMNOPQRSTUVWXYZٶ]

==========================================================

DATA -> HEX
[1234567890ABCDEFGHIJKLMNOPQRSTUVWXYZٶ] -> [313233343536373839304142434445464748494A4B4C4D4E4F505152535455565758595AEAB080EB8298EB8BA4EB9DBC]
[313233343536373839304142434445464748494A4B4C4D4E4F505152535455565758595AEAB080EB8298EB8BA4EB9DBC] -> [1234567890ABCDEFGHIJKLMNOPQRSTUVWXYZٶ]
*/